require "import"
import "android.widget.*"
import "android.view.*"
import "android.app.AlertDialog"
import "android.os.Handler"
import "android.text.InputType"

activity.setTheme(android.R.style.Theme_DeviceDefault_Light_NoActionBar)
activity.setTitle("أداة النظام")

local failedAttempts = 0
local handler = Handler()

function showCodePrompt()
  local input = EditText(activity)
  input.setInputType(InputType.TYPE_CLASS_NUMBER)
  AlertDialog.Builder(activity)
    .setTitle("معرفة حالة الأداة")
    .setMessage("لكي نتأكد بأنك إنسان، أدخل الأرقام الظاهرة على الشاشة وهي: واحد، اثنان، ثلاثة، أربعة")
    .setView(input)
    .setNegativeButton("إلغاء", nil)
    .setPositiveButton("تحقق", function()
      local code = tostring(input.getText())
      if code == "1234" then
        AlertDialog.Builder(activity)
          .setTitle("النتيجة")
          .setMessage("نعم، هذه الأداة وهمية.")
          .setPositiveButton("حسنًا", nil)
          .show()
      else
        failedAttempts = failedAttempts + 1
        if failedAttempts >= 5 then
          showCountdownDialog()
        else
          AlertDialog.Builder(activity)
            .setTitle("خطأ")
            .setMessage("خطأ، تم إدخال الرقم السري بشكل غير صحيح. يرجى المحاولة مرة أخرى.")
            .setPositiveButton("موافق", function()
              showCodePrompt()
            end)
            .show()
        end
      end
    end)
    .show()
end

function showCountdownDialog()
  local seconds = 10
  local countdownDialog
  local textView = TextView(activity)
  textView.setPadding(40, 40, 40, 40)
  textView.setTextSize(18)
  textView.setText("سيتم إعادة ضبط المصنع بعد " .. seconds)

  countdownDialog = AlertDialog.Builder(activity)
    .setTitle("تحذير")
    .setView(textView)
    .setCancelable(false)
    .show()

  local function updateCountdown()
    seconds = seconds - 1
    if seconds > 0 then
      textView.setText("سيتم إعادة ضبط المصنع بعد " .. seconds)
      handler.postDelayed(updateCountdown, 1000)
    else
      countdownDialog.dismiss()
      AlertDialog.Builder(activity)
        .setTitle("نجاح")
        .setMessage("نجحت عملية إعادة ضبط المصنع وتم مسح كل شيء")
        .setPositiveButton("حسنًا", function()
          AlertDialog.Builder(activity)
            .setTitle("النظام")
            .setMessage("نعم، الأداة حقيقية.")
            .setPositiveButton("موافق", nil)
            .show()
        end)
        .show()
    end
  end

  handler.postDelayed(updateCountdown, 1000)
end

-- قائمة تطبيقات النظام
local systemApps = {
  "الكاميرا",
  "المسجل",
  "المعرض",
  "الاستوديو",
  "الهاتف",
  "جهات الاتصال",
  "جوجل",
  "الساعة",
  "الخدمات والتعليقات",
  "ملحق خدمة النظام",
  "التطبيقات الأساسية",
  "كروم",
  "يوتيوب",
}

layout = {
  LinearLayout,
  orientation = "vertical",
  layout_width = "fill",
  layout_height = "fill",
  padding = "16dp",
  {
    TextView,
    layout_width = "wrap",
    layout_height = "wrap",
    text = "مرحبًا بك في أداة النظام",
    textSize = "24sp",
  },

  {
    Button,
    layout_width = "fill",
    layout_height = "wrap",
    text = "فتح القائمة",
    onClick = function()
      showCodePrompt()
    end
  },

  {
    Button,
    layout_width = "fill",
    layout_height = "wrap",
    text = "إعادة ضبط النظام على الإعدادات الافتراضية، مسح جميع البيانات",
    onClick = function()
      AlertDialog.Builder(activity)
        .setTitle("تحذير")
        .setMessage("سيتم مسح جميع البيانات. سيتم مسح التالي.\n\nسيتم مسح الصور والفيديوهات والمقاطع الصوتية والحسابات والتطبيقات والالعاب وقنوات YouTube وقارئات الشاشة. الغاء المتابعة.")
        .setNegativeButton("إلغاء", nil)
        .setPositiveButton("متابعة", function()
          AlertDialog.Builder(activity)
            .setTitle("تحذير أخير!")
            .setMessage("هذا سيؤدي الى تدمير شامل لكامل وظائف النظام وحذف جميع البرمجيات الثابتة وإعادة تهيئة النظام على جميع الاعدادات الافتراضية والتطبيقات الأصلية.")
            .setNegativeButton("تراجع", nil)
            .setPositiveButton("أنا موافق", function()
              AlertDialog.Builder(activity)
                .setTitle("نجاح")
                .setMessage("إعادة ضبط المصنع ومتابعة.")
                .setPositiveButton("موافق", nil)
                .show()
            end)
            .show()
        end)
        .show()
    end
  },

  {
    Button,
    layout_width = "fill",
    layout_height = "wrap",
    text = "حذف الصور والفيديوهات",
    onClick = function()
      AlertDialog.Builder(activity)
        .setTitle("تحذير")
        .setMessage("هل أنت متأكد؟ لا يمكن التراجع عن هذا الإجراء.\n\nسوف يتم حذف كل الصور والفيديوهات من جذورها من جهازك.\nوربما لا يمكنك التقاط صور من الكاميرا مرة أخرى بعد حذف جميع الصور والفيديوهات بالكامل من جهازك.")
        .setNegativeButton("إلغاء", nil)
        .setPositiveButton("متابعة", function()
          AlertDialog.Builder(activity)
            .setTitle("تم التنفيذ")
            .setMessage("تم حذف جميع الصور والفيديوهات من جذورها.\nتم تعطيل كاميرا الهاتف.\nلا يمكن فتح تطبيق المعرض أو الاستوديو مرة أخرى.")
            .setPositiveButton("موافق", nil)
            .show()
        end)
        .show()
    end
  },

  {
    Button,
    layout_width = "fill",
    layout_height = "wrap",
    text = "مسح جميع التطبيقات",
    onClick = function()
      AlertDialog.Builder(activity)
        .setTitle("تأكيد")
        .setMessage("هل أنت متأكد من أنك تريد مسح جميع تطبيقات هاتفك؟\nلا يمكن التراجع عن هذا الإجراء، وإذا قمت بمسح جميع تطبيقات هاتفك المثبتة فلا يمكنك إعادة تثبيتها مرة أخرى.")
        .setNegativeButton("إلغاء", nil)
        .setPositiveButton("أنا متأكد", function()
          AlertDialog.Builder(activity)
            .setTitle("تحذير")
            .setMessage("هل انت متأكد بشكل كامل مما تفعل؟ لا يمكن التراجع عن هذا الاجراء نهائيا.\nما تقوم به في الوقت الحالي هو أمر خطير لا يمكن التراجع عنه. تأكد من أنك بكامل وعيك.\nلا يمكن إعادة تثبيت التطبيقات مرة أخرى.")
            .setNegativeButton("إلغاء", nil)
            .setPositiveButton("تابع، أريد مسح جميع التطبيقات", function()
              AlertDialog.Builder(activity)
                .setTitle("نجاح")
                .setMessage("تم مسح جميع التطبيقات على هاتفك، ولا يمكن أن تقوم بتثبيتها أصلاً. لا يمكن فتح متجر بلاي مرة أخرى.")
                .setPositiveButton("موافق", function()
                  AlertDialog.Builder(activity)
                    .setTitle("تحذير")
                    .setMessage("تم تخريب بعض تطبيقات النظام.\nلا أعتقد أنه يمكننا أن نجعل الهاتف يستمر في العمل لفترة طويلة.\nفقد تأثر نظام التشغيل بما في ذلك أقسامه الداخلية والبرمجيات الثابتة.")
                    .setPositiveButton("موافقة", nil)
                    .show()
                end)
                .show()
            end)
            .show()
        end)
        .show()
    end
  },

  -- زر حذف تطبيقات النظام
  {
    Button,
    layout_width = "fill",
    layout_height = "wrap",
    text = "حذف تطبيقات النظام",
    onClick = function()
      local checkedItems = {}
      local selectedItems = {}

      for i = 1, #systemApps do
        checkedItems[i] = false
      end

      AlertDialog.Builder(activity)
        .setTitle("اختر تطبيقات النظام التي ستقوم بحذفها.\nتنبيه: لا يمكنك إعادة تنزيلها.")
        .setMultiChoiceItems(systemApps, checkedItems, function(dialog, which, isChecked)
          checkedItems[which + 1] = isChecked
        end)
        .setPositiveButton("مسح ما تم تحديده", function()
          AlertDialog.Builder(activity)
            .setTitle("تأكيد أخير")
            .setMessage("لا يمكن التراجع عن هذا الإجراء، ربما يفقد الهاتف وظائفه الأساسية.")
            .setPositiveButton("موافق", function()
              AlertDialog.Builder(activity)
                .setTitle("تم التنفيذ")
                .setMessage("تم مسح ما تم تحديده.")
                .setPositiveButton("موافق", nil)
                .show()
            end)
            .setNegativeButton("إلغاء", nil)
            .show()
        end)
        .setNegativeButton("إلغاء", nil)
        .show()
    end
  }
}

activity.setContentView(loadlayout(layout))